; SPIRITUS SANCTUS 2 (2013) for realtime Csound5/6 - by Arthur B. Hunkins
;  requires MIDI device with 8 knobs/sliders

<CsoundSynthesizer>
<CsOptions>

; for Windows, Mac
-odac -M0  -m0d --expression-opt -b128 -B2048 -+raw_controller_mode=1
; for Linux
;-odac -+rtaudio=alsa -+rtmidi=alsa -M hw:1,0 -m0d --expression-opt -b128 -B2048 -+raw_controller_mode=1

</CsOptions>
<CsInstruments>

sr	=	 44100
ksmps	=	 100
nchnls  =        2

#define CHAN     #1# ; 0 = CC7, CHAN 1-8 
#define CTRL     #20# ; 1st # of 8 consecutive; valid = 0 - 120

        instr 1
   
gkamp	ctrl7    ($CHAN == 0? 1: $CHAN), ($CHAN == 0? 7: $CTRL), 0, 1
gkamp   tab      gkamp * 511, 2
gkamp   =        gkamp * 12000
gkamp   port     gkamp, .1
kmul    ctrl7    ($CHAN == 0? 2: $CHAN), ($CHAN == 0? 7: $CTRL + 1), 0, .82
kmul    port     kmul, .1
knh     ctrl7    ($CHAN == 0? 3: $CHAN), ($CHAN == 0? 7: $CTRL + 2), 4, 20
gklh    ctrl7    ($CHAN == 0? 4: $CHAN), ($CHAN == 0? 7: $CTRL + 3), 4, 10.1
gkamp2  ctrl7    ($CHAN == 0? 8: $CHAN), ($CHAN == 0? 7: $CTRL + 7), 0, .6
kamp2   rspline  -gkamp2, gkamp2, .6 * gklh, gklh
kamp2   port     kamp2, .01 
aout    gbuzz    gkamp + (kamp2 * gkamp), 200, knh, gklh, kmul, 1
        outs     aout, aout * .7
        
        endin
        
        instr 2
   
kmul    ctrl7    ($CHAN == 0? 5: $CHAN), ($CHAN == 0? 7: $CTRL + 4), 0, .82
kmul    port     kmul, .1
knh     ctrl7    ($CHAN == 0? 6: $CHAN), ($CHAN == 0? 7: $CTRL + 5), 4, 20
kfreq   ctrl7    ($CHAN == 0? 7: $CHAN), ($CHAN == 0? 7: $CTRL + 6), 0, .15
kfreq   port     kfreq, .01 
kamp2   rspline  -gkamp2, gkamp2, .6 * gklh, gklh
kamp2   port     kamp2, .01 
aout    gbuzz    gkamp + (kamp2 * gkamp), 200.05 + kfreq, knh, gklh, kmul, 1
        outs     aout * .7, aout
        
        endin

</CsInstruments>
<CsScore>

f1 0 16384 11 16 1 .012
f2 0 512 16 0 512 .8 1

i1 0 3600
i2 0 3600

</CsScore>
</CsoundSynthesizer> 